#include<bits/stdc++.h>
using namespace std;
#define ll long long
int main(){
    int n,q;
    cin>>n>>q;
    ll d[n+1];
    int p[n+1];
    ll k[q+1];
    for(int i=1;i<=n;i++){
        cin>>d[i]>>p[i];
    }
    for(int i=1;i<=q;i++){
        cin>>k[i];
    }

    ll maks=k[q];
    ll niz[maks+1]={0};
    ll novi[maks+1]={0};

    int br=1;
    for(ll i=1;i<=maks;i++){
        if(n>=br){
            if(i==d[br]){
            novi[i]=p[br];
            br++;
            } else {
                novi[i]=0;
            }
        }
    }

    ll b=0;
    for(ll i=1;i<=maks;i++){
        b+=novi[i];
        if(b>0){
            niz[i]=1;
            b--;
        } else {
            niz[i]=0;
        }
    }

    for(ll i=2;i<=maks;i++){
        niz[i]=niz[i-1]+niz[i];
    }
    for(ll i=1;i<=q;i++){
        cout<<niz[k[i]]<<endl;
    }
}